import pymel.core as pm
from alShaders import alShadersTemplate

class AEalSurfaceTemplate(alShadersTemplate):
	def setup(self):
		self.addSwatch()
		self.beginScrollLayout()

		self.beginLayout("Matte")
		self.addControl("aiEnableMatte", label="Enable Matte")
		self.addControl("aiMatteColor", label="Matte Color")
		self.addControl("aiMatteColorA", label="Matte Opacity")
		self.endLayout()
		self.beginLayout("Diffuse", collapse=False)
		self.addControl("diffuseStrength", label="Strength")
		self.addControl("diffuseColor", label="Color")
		self.addControl("diffuseRoughness", label="Roughness")
		self.beginLayout("Backlight", collapse=True)
		self.addControl("backlightStrength", label="Strength")
		self.addControl("backlightColor", label="Color")
		self.addControl("backlightIndirectStrength", label="Indirect strength")
		self.endLayout() # END Backlight
		self.beginLayout("SSS", collapse=True)
		self.addControl("sssMix", label="Mix")
		self.addControl("sssDensityScale", label="Density scale")
		self.addControl("sssRadius", label="Distance 1")
		self.addControl("sssWeight1", label="Weight 1")
		self.addControl("sssRadiusColor", label="Color 1")
		self.addControl("sssRadius2", label="Distance 2")
		self.addControl("sssWeight2", label="Weight 2")
		self.addControl("sssRadiusColor2", label="Color 2")
		self.addControl("sssRadius3", label="Distance 3")
		self.addControl("sssWeight3", label="Weight 3")
		self.addControl("sssRadiusColor3", label="Color 3")
		self.endLayout() # END SSS
		self.beginLayout("Advanced", collapse=True)
		self.addControl("diffuseExtraSamples", label="Extra samples")
		self.addControl("diffuseEnableCaustics", label="Enable caustics")
		self.addControl("diffuseIndirectStrength", label="Indirect strength")
		self.addControl("traceSetDiffuse", label="Diffuse trace set")
		self.addControl("traceSetBacklight", label="Backlight trace set")
		self.endLayout() # END Advanced
		self.endLayout() # END Diffuse
		self.beginLayout("Specular 1", collapse=False)
		self.addControl("specular1Strength", label="Strength")
		self.addControl("specular1Color", label="Color")
		self.addControl("specular1Roughness", label="Roughness")
		self.addControl("specular1Anisotropy", label="Anisotropy")
		self.addControl("specular1Rotation", label="Rotation")
		self.addControl("specular1Ior", label="IOR")
		self.beginLayout("Advanced", collapse=True)
		self.addControl("specular1RoughnessDepthScale", label="Roughness depth scale")
		self.addControl("specular1ExtraSamples", label="Extra samples")
		self.addControl("specular1Normal", label="Normal")
		self.addControl("specular1IndirectStrength", label="Indirect strength")
		self.addControl("specular1IndirectClamp", label="Indirect clamp")
		self.addControl("traceSetSpecular1", label="Trace set")
		self.endLayout() # END Advanced
		self.endLayout() # END Specular 1
		self.beginLayout("Specular 2", collapse=True)
		self.addControl("specular2Strength", label="Strength")
		self.addControl("specular2Color", label="Color")
		self.addControl("specular2Roughness", label="Roughness")
		self.addControl("specular2Anisotropy", label="Anisotropy")
		self.addControl("specular2Rotation", label="Rotation")
		self.addControl("specular2Ior", label="IOR")
		self.beginLayout("Advanced", collapse=True)
		self.addControl("specular2RoughnessDepthScale", label="Roughness depth scale")
		self.addControl("specular2ExtraSamples", label="Extra samples")
		self.addControl("specular2Normal", label="Normal")
		self.addControl("specular2IndirectStrength", label="Indirect strength")
		self.addControl("specular2IndirectClamp", label="Indirect clamp")
		self.addControl("traceSetSpecular2", label="Trace set")
		self.endLayout() # END Advanced
		self.endLayout() # END Specular 2
		self.beginLayout("Transmission", collapse=True)
		self.addControl("transmissionStrength", label="Strength")
		self.addControl("transmissionColor", label="Color")
		self.addControl("transmissionLinkToSpecular1", label="Link to specular 1")
		self.addControl("transmissionRoughness", label="Roughness")
		self.addControl("transmissionIor", label="IOR")
		self.beginLayout("Attenuation", collapse=True)
		self.addControl("ssAttenuationColor", label="Color")
		self.addControl("ssInScatteringStrength", label="Scattering")
		self.addControl("ssDensityScale", label="Density scale")
		self.addControl("ssDirection", label="Direction")
		self.endLayout() # END Attenuation
		self.beginLayout("Advanced", collapse=True)
		self.addControl("transmissionRoughnessDepthScale", label="Roughness depth scale")
		self.addControl("transmissionExtraSamples", label="Extra samples")
		self.addControl("transmissionEnableCaustics", label="Enable internal reflections")
		self.addControl("rrTransmission", label="RR")
		self.addControl("rrTransmissionDepth", label="RR depth")
		self.addControl("transmissionClamp", label="Indirect clamp")
		self.addControl("ssSpecifyCoefficients", label="Specify attenuation coeffs.")
		self.addControl("ssScattering", label="Scattering")
		self.addControl("ssAbsorption", label="Absorption")
		self.addControl("traceSetTransmission", label="Trace set")
		self.endLayout() # END Advanced
		self.endLayout() # END Transmission
		self.beginLayout("Emission", collapse=True)
		self.addControl("emissionStrength", label="Strength")
		self.addControl("emissionColor", label="Color")
		self.endLayout() # END Emission
		self.addControl("opacity", label="Opacity")
		self.beginLayout("IDs", collapse=True)
		self.addControl("id1", label="id1")
		self.addControl("id2", label="id2")
		self.addControl("id3", label="id3")
		self.addControl("id4", label="id4")
		self.addControl("id5", label="id5")
		self.addControl("id6", label="id6")
		self.addControl("id7", label="id7")
		self.addControl("id8", label="id8")
		self.endLayout() # END IDs
		self.beginLayout("AOVs", collapse=True)
		self.addControl("lightGroupsIndirect", label="Indirect light groups")
		self.addControl("standardCompatibleAOVs", label="Write standard AOVs only")
		self.addControl("transmitAovs", label="Transmit AOVs")
		self.addControl("aov_diffuse_color", label="Diffuse color")
		self.addControl("aov_direct_diffuse", label="Direct diffuse")
		self.addControl("aov_direct_diffuse_raw", label="Direct diffuse (raw)")
		self.addControl("aov_indirect_diffuse", label="Indirect diffuse")
		self.addControl("aov_indirect_diffuse_raw", label="Indirect diffuse (raw)")
		self.addControl("aov_direct_backlight", label="Direct backlight")
		self.addControl("aov_indirect_backlight", label="Indirect backlight")
		self.addControl("aov_direct_specular", label="Direct specular")
		self.addControl("aov_indirect_specular", label="Indirect specular")
		self.addControl("aov_direct_specular_2", label="Direct specular 2")
		self.addControl("aov_indirect_specular_2", label="Indirect specular 2")
		self.addControl("aov_single_scatter", label="Single scatter")
		self.addControl("aov_sss", label="SSS")
		self.addControl("aov_refraction", label="Refraction")
		self.addControl("aov_emission", label="Emission")
		self.addControl("aov_uv", label="UV")
		self.addControl("aov_depth", label="Depth")
		self.addControl("aov_light_group_1", label="Light group [1]")
		self.addControl("aov_light_group_2", label="Light group [2]")
		self.addControl("aov_light_group_3", label="Light group [3]")
		self.addControl("aov_light_group_4", label="Light group [4]")
		self.addControl("aov_light_group_5", label="Light group [5]")
		self.addControl("aov_light_group_6", label="Light group [6]")
		self.addControl("aov_light_group_7", label="Light group [7]")
		self.addControl("aov_light_group_8", label="Light group [8]")
		self.addControl("aov_id_1", label="ID [1]")
		self.addControl("aov_id_2", label="ID [2]")
		self.addControl("aov_id_3", label="ID [3]")
		self.addControl("aov_id_4", label="ID [4]")
		self.addControl("aov_id_5", label="ID [5]")
		self.addControl("aov_id_6", label="ID [6]")
		self.addControl("aov_id_7", label="ID [7]")
		self.addControl("aov_id_8", label="ID [8]")
		self.addControl("aov_shadow_group_1", label="Shadow group [1]")
		self.addControl("aov_shadow_group_2", label="Shadow group [2]")
		self.addControl("aov_shadow_group_3", label="Shadow group [3]")
		self.addControl("aov_shadow_group_4", label="Shadow group [4]")
		self.addControl("aov_shadow_group_5", label="Shadow group [5]")
		self.addControl("aov_shadow_group_6", label="Shadow group [6]")
		self.addControl("aov_shadow_group_7", label="Shadow group [7]")
		self.addControl("aov_shadow_group_8", label="Shadow group [8]")
		self.endLayout() # END AOVs
		self.beginLayout("Advanced", collapse=True)
		self.addControl("rr", label="RR")
		self.addControl("traceSetAll", label="Global trace set")
		self.addControl("traceSetShadows", label="Shadow trace set")
		self.endLayout() # END Advanced
		self.addBumpLayout()

		pm.mel.AEdependNodeTemplate(self.nodeName)
		self.addExtraControls()

		self.endScrollLayout()
